Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.joda.time
Interface ReadablePartial

All Known Implementing Classes:
  AbstractPartial, BaseLocal, BasePartial, LocalDate, LocalDateTime, LocalTime, Partial, TimeOfDay, YearMonthDay

    public interface ReadablePartial

Defines a partial time that does not support every datetime field, and is thus a local time.

A `ReadablePartial` supports a subset of those fields on the chronology. It cannot be compared to a `ReadableInstant`, as it does not fully specify an instant in time. The time it does specify is a local time, and does not include a time zone.

A `ReadablePartial` can be converted to a `ReadableInstant` using the `toDateTime` method. This works by providing a full base instant that can be used to 'fill in the gaps' and specify a time zone.

Since:
  1.0
Author:
  Stephen Colebourne

Method Summary
`boolean` | `equals(java.lang.Object partial)` Compares this partial with the specified object for equality based on the supported fields, chronology and values.
`int` | `get(DateTimeFieldType field)` Gets the value of one of the fields.
`Chronology` | `getChronology()` Gets the chronology of the partial which is never null.
`DateTimeField` | `getField(int index)` Gets the field at the specified index.
`DateTimeFieldType` | `getFieldType(int index)` Gets the field type at the specified index.
`int` | `getValue(int index)` Gets the value at the specified index.
`int` | `hashCode()` Gets a hash code for the partial that is compatible with the equals method.
`boolean` | `isSupported(DateTimeFieldType field)` Checks whether the field type specified is supported by this partial.
`int` | `size()` Gets the number of fields that this partial supports.
`DateTime` | `toDateTime(ReadableInstant baseInstant)` Converts this partial to a full datetime by resolving it against another datetime.
`java.lang.String` | `toString()` Get the value as a String in a recognisable ISO8601 format, only displaying supported fields.

Method Detail

### size

    int size()

  Gets the number of fields that this partial supports.

  Returns:
    the number of fields supported

### getFieldType

    DateTimeFieldType getFieldType(int index)

  Gets the field type at the specified index.

  Parameters:
    `index` - the index to retrieve
  Returns:
    the field at the specified index
  Throws:
    `java.lang.IndexOutOfBoundsException` - if the index is invalid

### getField

    DateTimeField getField(int index)

  Gets the field at the specified index.

  Parameters:
    `index` - the index to retrieve
  Returns:
    the field at the specified index
  Throws:
    `java.lang.IndexOutOfBoundsException` - if the index is invalid

### getValue

    int getValue(int index)

  Gets the value at the specified index.

  Parameters:
    `index` - the index to retrieve
  Returns:
    the value of the field at the specified index
  Throws:
    `java.lang.IndexOutOfBoundsException` - if the index is invalid

### getChronology

    Chronology getChronology()

  Gets the chronology of the partial which is never null.

  The `Chronology` is the calculation engine behind the partial and provides conversion and validation of the fields in a particular calendar system.

  Returns:
    the chronology, never null

### get

    int get(DateTimeFieldType field)

  Gets the value of one of the fields.

  The field type specified must be one of those that is supported by the partial.

  Parameters:
    `field` - a DateTimeFieldType instance that is supported by this partial
  Returns:
    the value of that field
  Throws:
    `java.lang.IllegalArgumentException` - if the field is null or not supported

### isSupported

    boolean isSupported(DateTimeFieldType field)

  Checks whether the field type specified is supported by this partial.

  Parameters:
    `field` - the field to check, may be null which returns false
  Returns:
    true if the field is supported

### toDateTime

    DateTime toDateTime(ReadableInstant baseInstant)

  Converts this partial to a full datetime by resolving it against another datetime.

  This method takes the specified datetime and sets the fields from this instant on top. The chronology from the base instant is used.

  For example, if this partial represents a time, then the result of this method will be the datetime from the specified base instant plus the time from this partial.

  Parameters:
    `baseInstant` - the instant that provides the missing fields, null means now
  Returns:
    the combined datetime

### equals

    boolean equals(java.lang.Object partial)

  Compares this partial with the specified object for equality based on the supported fields, chronology and values.

  Two instances of ReadablePartial are equal if they have the same chronology, same field types (in same order) and same values.

  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `partial` - the object to compare to
  Returns:
    true if equal

### hashCode

    int hashCode()

  Gets a hash code for the partial that is compatible with the equals method.

  The formula used must be:

        int total = 157;
        for (int i = 0; i < fields.length; i++) {
            total = 23 * total + values[i];
            total = 23 * total + fieldTypes[i].hashCode();
        }
        total += chronology.hashCode();
        return total;

  Overrides:
    `hashCode` in class `java.lang.Object`
  Returns:
    a suitable hash code

### toString

    java.lang.String toString()

  Get the value as a String in a recognisable ISO8601 format, only displaying supported fields.

  The string output is in ISO8601 format to enable the String constructor to correctly parse it.

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    the value as an ISO8601 string

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD